Docs

Build Midnight collateral-withdrawal calls

Builds calls that withdraw exact or complete balances of one or more configured collaterals from a Midnight position.


POST
/v0/actions/midnight/markets/{market-selector}/withdraw-collateral

Collaterals are processed in request order, addresses must be unique, and the response never requires signatures.

Authorization

ApiKeyAuth
x-api-key<token>

Send your Morpho-issued key on every action request. JWKS needs no key on every host; public documentation needs no key.

In: header

Path Parameters

market-selector*string

Midnight market selector formatted as <chain_id>:<market_id>. The colon may be sent literally or as %3A.

Match^(?:[1-9][0-9]{0,14}|[1-8][0-9]{15}|900[0-6][0-9]{12}|90070[0-9]{11}|90071[0-8][0-9]{10}|900719[0-8][0-9]{9}|9007199[0-1][0-9]{8}|90071992[0-4][0-9]{7}|900719925[0-3][0-9]{6}|9007199254[0-6][0-9]{5}|90071992547[0-3][0-9]{4}|9007199254740[0-8][0-9]{2}|90071992547409[0-8][0-9]{1}|9007199254740990|9007199254740991):0x[0-9a-fA-F]{64}$

Request Body

application/json

TypeScript Definitions

Use the request body type in TypeScript.

Response Body

application/json

application/json

application/json

application/json

application/json

application/json

application/json

curl -X POST "https://example.com/v0/actions/midnight/markets/{market-selector}/withdraw-collateral" \  -H "Content-Type: application/json" \  -d '{    "account": "0x6aBB9Aeb93e9aF04c8D9FD2b84BF6ca8EDC3eAf2",    "collateral_withdrawals": [      {        "collateral": {          "address": "0xFa750DD0099eAdB72d401244De73ce7B89edf90F"        },        "amount": {          "unit": "all"        }      },      {        "collateral": {          "address": "0x2Ae3F1Ec7F1F5012CFEab0185bfc7aa3cf0DEc22"        },        "amount": {          "unit": "assets",          "value": "500000"        }      }    ]  }'
{  "data": {    "action_id": "act_0123456789abcdef0123456789abcdef",    "status": "prepared",    "chain_id": 8453,    "account": "0x6aBB9Aeb93e9aF04c8D9FD2b84BF6ca8EDC3eAf2",    "expires_at": 1760001800,    "market": {      "id": "0xcdea4ca06837feca3026b23a95f0bd96c3eabdc77d1211472ce0346fcc200649",      "loan_asset": {        "address": "0x4200000000000000000000000000000000000006"      },      "collaterals": [        {          "address": "0x2Ae3F1Ec7F1F5012CFEab0185bfc7aa3cf0DEc22"        },        {          "address": "0xFa750DD0099eAdB72d401244De73ce7B89edf90F"        }      ]    },    "action": "midnight.withdraw_collateral",    "collateral_withdrawals": [      {        "collateral": {          "address": "0xFa750DD0099eAdB72d401244De73ce7B89edf90F"        },        "amount": {          "unit": "all"        }      },      {        "collateral": {          "address": "0x2Ae3F1Ec7F1F5012CFEab0185bfc7aa3cf0DEc22"        },        "amount": {          "unit": "assets",          "value": "500000"        }      }    ],    "calls": [      {        "id": "call_0",        "kind": "repay_and_withdraw_collateral",        "to": "0x0bF30B530f816a619C3F28a3b9f44C441122555D",        "data": "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",        "value": "0"      }    ],    "simulation": {      "status": "success",      "block": {        "number": "21000000",        "timestamp": 1760000000      },      "wallet_changes": [        {          "asset": {            "type": "erc20",            "address": "0x2Ae3F1Ec7F1F5012CFEab0185bfc7aa3cf0DEc22"          },          "difference": "500000"        },        {          "asset": {            "type": "erc20",            "address": "0xFa750DD0099eAdB72d401244De73ce7B89edf90F"          },          "difference": "250000"        }      ],      "position_changes": {        "collaterals": [          {            "collateral": {              "address": "0xFa750DD0099eAdB72d401244De73ce7B89edf90F"            },            "difference": "-250000"          },          {            "collateral": {              "address": "0x2Ae3F1Ec7F1F5012CFEab0185bfc7aa3cf0DEc22"            },            "difference": "-500000"          }        ]      },      "effects": {        "withdrawn_collaterals": [          {            "collateral": {              "address": "0xFa750DD0099eAdB72d401244De73ce7B89edf90F"            },            "assets": "250000"          },          {            "collateral": {              "address": "0x2Ae3F1Ec7F1F5012CFEab0185bfc7aa3cf0DEc22"            },            "assets": "500000"          }        ]      }    }  }}
{  "error": {    "code": "REQUEST_ABORTED",    "message": "string",    "details": [      {        "code": "string",        "message": "string",        "path": [          "string"        ],        "rule": "string",        "details": {          "min_assets": "string",          "loan_token": "string"        }      }    ],    "request_id": "string"  }}
{  "error": {    "code": "MARKET_NOT_FOUND",    "message": "string",    "details": [      {        "code": "string",        "message": "string",        "path": [          "string"        ],        "rule": "string",        "details": {          "min_assets": "string",          "loan_token": "string"        }      }    ],    "request_id": "string"  }}
{  "error": {    "code": "PAYLOAD_TOO_LARGE",    "message": "string",    "details": [      {        "code": "string",        "message": "string",        "path": [          "string"        ],        "rule": "string",        "details": {          "min_assets": "string",          "loan_token": "string"        }      }    ],    "request_id": "string"  }}
{  "error": {    "code": "ACTION_UNSUPPORTED",    "message": "This action is not supported.",    "details": null,    "request_id": "req_0123456789abcdef0123456789abcdef"  }}
Empty
{  "error": {    "code": "INTERNAL_ERROR",    "message": "string",    "details": [      {        "code": "string",        "message": "string",        "path": [          "string"        ],        "rule": "string",        "details": {          "min_assets": "string",          "loan_token": "string"        }      }    ],    "request_id": "string"  }}
{  "error": {    "code": "CONTRACT_CODE_MISSING",    "message": "string",    "details": [      {        "code": "string",        "message": "string",        "path": [          "string"        ],        "rule": "string",        "details": {          "min_assets": "string",          "loan_token": "string"        }      }    ],    "request_id": "string"  }}